﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Package : MonoBehaviour
{
	public Vector2 Target = Vector2.zero;
	public GameObject PackageTargetPrefab = null;
	public GameObject ExplosionPrefab = null;
	public PackageTarget PTarget = null;
	public GameObject Carrier = null;
	public int ScoreReward = 0;
	public ParticleSystem Particles;
	public bool Delivered = false;

	public void CalculateTarget()
	{
		Target = GameController.GetValidSpawnPoint();

        ScoreReward = (int)Vector2.Distance(new Vector2(transform.position.x, transform.position.y), Target);

		Bounds gridBounds = GameController.GridBounds;
		float maxScore = Mathf.Max(gridBounds.size.x, gridBounds.size.y);
		float scoreColorPercent = ScoreReward / maxScore;

#pragma warning disable 0618
		Particles.startColor = Color.yellow;
		Particles.startSize = 0.75f + (2.25f * scoreColorPercent);
		Particles.startLifetime = 2f + (4f * scoreColorPercent);
#pragma warning restore 0618
	}

	public void SpawnTarget()
	{
		if (PTarget == null)
		{
			GameObject pTargetGameObject = Instantiate(PackageTargetPrefab, new Vector3(Target.x, Target.y, 0f), Quaternion.identity);
			PTarget = pTargetGameObject.GetComponent<PackageTarget>();
			PTarget.ParentPackage = this;
		}
	}

	void OnDestroy()
	{
		if (Delivered == true)
		{
			GameObject explosion = Instantiate(ExplosionPrefab, transform.position, Quaternion.identity);
			ParticleSystem explosionParticles = explosion.GetComponent<ParticleSystem>();
#pragma warning disable 0618
			explosionParticles.startColor = Particles.startColor;
			explosionParticles.startSize = Particles.startSize;
#pragma warning restore 0618
		}
	}
}
