﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Spawner))]
public class PackageSpawner : MonoBehaviour {

    protected const string PACKAGE_TAG = "Package";

    // Chance of spawning a package per second (0-1)
    public float PackageFrequency = 0.5f;

    // Max number of packages spawned at a time
    public int MaxPackages = 5;

	// Check whether we should spawn a new package every second
	protected float packageSpawnCountdown;

    protected Object packageObj;

    // Use this for initialization
    void Start () {
        packageSpawnCountdown = 1.0f;

        packageObj = Resources.Load("Package");
    }

    // Update is called once per frame
    void Update () {
        packageSpawnCountdown -= Time.deltaTime;

        if (packageSpawnCountdown < 0) {
            bool canSpawnPackage = (GameObject.FindGameObjectsWithTag(PACKAGE_TAG).Length < MaxPackages)
                && Random.Range(0, 1) < PackageFrequency;

            if (canSpawnPackage) {
                GetComponent<Spawner>().Spawn(packageObj);
            }

            packageSpawnCountdown = 1.0f;
        }
    }
}
