﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Pathfinding;

[RequireComponent(typeof(Seeker))]
[RequireComponent(typeof(LineRenderer))]
public class PlayerNav : MonoBehaviour {

    protected Vector3 curPathPosition;
    protected Vector3 curPathTargetPosition;
    private Seeker Seeker = null;
	private LineRenderer Line = null;

	protected Vector3 targetPosition;
	public bool HasTarget;

	// Use this for initialization
	void Start () {
        Seeker = GetComponent<Seeker>();
        Line = GetComponent<LineRenderer>();
    }

    public Vector3 Target
    {
        set
        {
			targetPosition = value;
			HasTarget = true;
		}
    }

    // Update is called once per frame
    void Update ()
    {
        if (HasTarget == true)
        {
			Line.enabled = true;

			bool recalcPath = (transform.position != curPathPosition ||
							targetPosition != curPathTargetPosition);

			// Don't try to recalculate another path while we're still calculating
			// the old one
			if (recalcPath && Seeker.IsDone())
			{
				curPathPosition = transform.position;
				curPathTargetPosition = targetPosition;
				Seeker.StartPath(curPathPosition, curPathTargetPosition, UpdatePath);
			}
        }
        else
        {
			Line.enabled = false;
		}
    }

    // protected Vector3 FindClosestPackagePosition() {
    //     var objectsWithTag = GameObject.FindGameObjectsWithTag("Package");
    //     GameObject curObject;
    //     float closestObjectDistance = Mathf.Infinity;
    //     Vector3 closestObjectPosition = Vector3.zero;

    //     for (int i = 0; i < objectsWithTag.Length; ++i) {

    //         curObject = objectsWithTag[i];
    //         float objectDistance = Vector3.Distance(transform.position,
    //                                                 curObject.transform.position);
    //         if (objectDistance < closestObjectDistance) {
    //             closestObjectDistance = objectDistance;
    //             closestObjectPosition = curObject.transform.position;
    //         }
    //     }

    //     return closestObjectPosition;
    // }

    protected void UpdatePath(Path p) 
    {
        if (!p.error) 
        {
            Line.positionCount = p.vectorPath.Count;
            for (int i = 0; i < p.vectorPath.Count; ++i) {
                Line.SetPosition(i, p.vectorPath[i]);
            }
        }
    }
}
