﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(ParticleSystem))]
[RequireComponent(typeof(CircleCollider2D))]
public class Pulse : MonoBehaviour {

    public ParticleSystem Particles;

    public float PulseRadius = 10f;
    public float PulseDuration = 0.5f;

    private float CurPulseDuration;

    void Start() {
        CurPulseDuration = PulseDuration;
        GetComponent<CircleCollider2D>().radius = PulseRadius;
        ParticleSystem.ShapeModule shapeModule = GetComponent<ParticleSystem>().shape;
        shapeModule.radius = PulseRadius;
    }

    // Update is called once per frame
    void Update () {
        if (CurPulseDuration < 0) {
            Destroy(gameObject);
        }

        CurPulseDuration -= Time.deltaTime;
    }
}
